<?php

namespace FiloBlu\Refilo\Controller\Adminhtml\Exporter;

use Exception;
use FiloBlu\Refilo\Model\Indexer\Blocks as IndexerBlocks;
use Magento\Framework\App\Action\HttpGetActionInterface as HttpGetActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Message\ManagerInterface;

class Cmsblocks implements HttpGetActionInterface
{
    /**
     * @var
     */
    private $messageManager;
    /**
     * @var ResultFactory
     */
    private $resultFactory;
    /**
     * @var IndexerBlocks
     */
    protected $blocksIndexer;

    /**
     * Countries constructor.
     * @param ResultFactory $resultFactory
     * @param ManagerInterface $messageManager
     * @param IndexerBlocks $indexerBlocks
     */
    public function __construct(
        ResultFactory $resultFactory,
        ManagerInterface $messageManager,
        IndexerBlocks $indexerBlocks
    ) {
        $this->resultFactory = $resultFactory;
        $this->messageManager = $messageManager;
        $this->blocksIndexer = $indexerBlocks;
    }

    public function execute()
    {
        try {
            $this->blocksIndexer->executeFull();
            $this->messageManager->addSuccessMessage(__('CMS blocks successfully synced with MongoDB'));
        } catch (Exception $e) {
            $this->messageManager->addExceptionMessage($e);
        }

        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('indexer/indexer/list/');
    }
}
