<?php

namespace FiloBlu\Refilo\Plugins;

class PageDataProvider
{
    public function afterGetData(\Magento\Cms\Model\Page\DataProvider $subject, $result)
    {
        foreach ($result as &$page) {
            if (!isset($page['og_data_image']) || empty($page['og_data_image'])) {
                continue;
            }
            $url = $page['og_data_image'];
            $imageInfo = pathinfo(parse_url($url, \PHP_URL_PATH));
            $page['og_data_image'] = [0 => [
                'url' => $url,
                'name' => $imageInfo['basename'],
                'size' => 0,
                'type' => 'image/' . $imageInfo['extension']
                ]
            ];
        }
        return $result;
    }
}
