<?php

namespace FiloBlu\Refilo\Remote\Entity;

use Magento\Catalog\Api\Data\CategoryInterface;

/**
 * Class MagentoToRefiloCategoryAdapter
 * @package FiloBlu\Refilo\Remote\Entity
 */
class MagentoToRefiloCategoryAdapter
{

    /**
     * @param CategoryInterface $magentoCategory
     * @param Category $refiloCategory
     * @return Category
     */
    public function adapt(CategoryInterface $magentoCategory, Category $refiloCategory): Category
    {
        $url = parse_url($magentoCategory->getUrl());
        $image = ($magentoCategory->getData('image')) ? '/catalog/category/' . $magentoCategory->getData('image') : null;

        $childrenCategories = $magentoCategory->getChildren();

        $children = [];
        if ($childrenCategories) {
            $children = array_map('intval', explode(',', $childrenCategories));
        }

        return $refiloCategory
            ->setId($magentoCategory->getId())
            ->setParentId($magentoCategory->getParentId())
            ->setPosition($magentoCategory->getPosition())
            ->setCreatedAt($magentoCategory->getCreatedAt())
            ->setUpdatedAt($magentoCategory->getUpdatedAt())
            ->setPath($url['path'])
            ->setPosition($magentoCategory->getPosition())
            ->setLevel($magentoCategory->getLevel())
            ->setChildrenCount($magentoCategory->getChildrenCount())
            ->setName($magentoCategory->getName())
            ->setDescription($magentoCategory->getDescription())
            ->setMetaTitle($magentoCategory->getMetaTitle())
            ->setMetaKeywords($magentoCategory->getMetaKeywords())
            ->setMetaDescription($magentoCategory->getMetaDescription())
            ->setImage($image)
            ->setChilds($children);
    }
}
